#! /boot/home/config/bin/perl
use diagnostics;
use POSIX;

print "<html><head><title>BeSharestats</title></head>";
print "<body bgcolor=\"#CCCCFF\">";
print "<h1>BeShare Upload statistics</h1>\n";
print '<p>(c) <a href="http://solweb.no/andreas">Andreas &Aring;kre Solberg</A>';
print ', <a href="mailto:beos@solweb.no">beos@solweb.no</a>';
print "<br>version 0.9\n\n";


# Scan all besahre logs
foreach $filnavn (@ARGV) {
	read_log($filnavn);
}


# This method reads an beshare file
sub read_log {
	open(EFIL, $filnavn) || die("Cannot open file: $filnavn");
	while (<EFIL>) {
		chop;
		if (/\[(.*?)\ .*?].*?\(a\.k\.a\. (.*?)\) is downloading (.*)/) {
			$filer{$3}++;
			$bruker{$2}++;
			$date_dl{$1}++;
		} elsif (/\[(.*?)\ .*?\]\ \([0-9]+\)\ (.*?):\ (.+)/) {
#			print "<p>-$1-$2-\<br><br>";
			$date_chat{$1}++;
			$bruker_chat{$2}++;
		}
	}
	close(EFIL);
}

sub max_num {
	$max = 0;
	my %list = @_;
	foreach my $item (keys %list) {
		$max = $list{$item} if $list{$item} > $max;
	}
	return $max;
}

$WIDTH=200;
$bgc[0] = "#DDEEDD";
$bgc[1] = "#EEDDEE";

$d = strftime("%d. %h %Y  %H:%M", gmtime);

print "<p>Last updated: $d";

print "<h2>Top 20 files</h2>\n";
print "<table>";
print "<tr bgcolor=\"BCDEBC\"><td>Nr.</td><td>File</td><td>Count</td><td>..</td></tr>";
$count = 0;
$maxf =  max_num(%filer);
foreach $fil (sort { $filer{$b} <=> $filer{$a} }  keys %filer ) {
	if ( ++$count <= 20)  {
		$tc= $bgc[($count % 2)];
		$tw= int( ($filer{$fil}*$WIDTH)/$maxf);
		print "<tr bgcolor=\"$tc\"><td width=\"50\">$count</td>";
		print "<td width=\"300\">$fil</td>";
		print "<td width=\"50\">$filer{$fil}</td>";
		print "<td width=\"200\"><img alt=\"$filer{$fil} files\" src=\"bar.gif\" width=\"$tw\" height=\"10\"></td></tr>\n";
	}
}
print "</table>";

print "<h2>Top 20 users downloading</h2>\n";
print "<table>";
print "<tr bgcolor=\"BCDEBC\"><td>Nr.</td><td>User</td><td>Downloads</td><td>..</td></tr>";
$count = 0;
$maxf = max_num(%bruker);
foreach $u (sort { $bruker{$b} <=> $bruker{$a} }  keys %bruker ) {
	if ( ++$count <= 20 ) {
		$tc= $bgc[($count % 2)];	
		$tw= int( ($bruker{$u}*$WIDTH)/$maxf);
		print "<tr bgcolor=\"$tc\"><td width=\"50\">$count</td>";
		print "<td width=\"300\">$u</td>";
		print "<td width=\"50\">$bruker{$u}</td>";
		print "<td width=\"200\"><img alt=\"$bruker{$u} files\" src=\"bar.gif\" width=\"$tw\" height=\"10\"></td></tr>\n";
	}
}
print "</table>";

print "<h2>Top 50 users chatting</h2>\n";
print "<table>";
print "<tr bgcolor=\"BCDEBC\"><td>Nr.</td><td>User</td><td>Lines</td><td>..</td></tr>";
$count = 0;
$maxf = max_num(%bruker_chat);
foreach $u (sort { $bruker_chat{$b} <=> $bruker_chat{$a} }  keys %bruker_chat ) {
	if ( ++$count <= 50 ) {
		$tc= $bgc[($count % 2)];	
		$tw= int( ($bruker_chat{$u}*$WIDTH)/$maxf);
		print "<tr bgcolor=\"$tc\"><td width=\"50\">$count</td>";
		print "<td width=\"300\">$u</td>";
		print "<td width=\"50\">$bruker_chat{$u}</td>";
		print "<td width=\"200\"><img alt=\"$bruker_chat{$u} lines\" src=\"bar.gif\" width=\"$tw\" height=\"10\"></td></tr>\n";
	}
}
print "</table>";

print "<h2>Chatting activity by date</h2>\n";
print "<table>";
print "<tr bgcolor=\"BCDEBC\"><td>Nr.</td><td>Date</td><td>Lines</td><td>..</td></tr>";
$count = 0;
$maxf = max_num(%date_chat);
foreach $u ( sort keys %date_chat ) {
	if ( ++$count <= 100 ) {
		$tc= $bgc[($count % 2)];	
		$tw= int( ($date_chat{$u}*$WIDTH)/$maxf);
		print "<tr bgcolor=\"$tc\"><td width=\"50\">$count</td>";
		print "<td width=\"300\">$u</td>";
		print "<td width=\"50\">$date_chat{$u}</td>";
		print "<td width=\"200\"><img alt=\"$date_chat{$u} lines\" src=\"bar.gif\" width=\"$tw\" height=\"10\"></td></tr>\n";
	}
}
print "</table>";

print "<h2>Next version</h2>\n";
print "<p>Please visit BeBits for future improved versions..";
print '<br>Happy sharing! - <b>Tezla@BeShare</b>';
print "</body></html>";
